<?php

namespace App\Entity;

use App\Repository\NotConservedRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: NotConservedRepository::class)]
#[ORM\Table(name: 'non_conserv')]
class NotConserved implements \JsonSerializable
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 400, name: 'denominazione')]
    private ?string $denomination = null;

    private ?float $lat = null;

    private ?float $lng = null;

    private ?ArrayCollection $bibliographies = null;

    #[ORM\Column(length: 255, nullable: true, name: 'periodo')]
    private ?string $period = null;

    #[ORM\Column(length: 255, nullable: true, name: 'localita_generica')]
    private ?string $genericLocation = null;

    #[ORM\Column(type: Types::TEXT, nullable: true, name: 'descrizione_breve')]
    private ?string $shortDescription = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(string $id): static
    {
        $this->id = $id;

        return $this;
    }

    public function getdenomination(): ?string
    {
        return $this->denomination;
    }

    public function setdenomination(string $denomination): static
    {
        $this->denomination = $denomination;

        return $this;
    }

    public function getLat(): ?float
    {
        return $this->lat;
    }

    public function setLat(?float $lat): static
    {
        $this->lat = $lat;

        return $this;
    }

    public function getLng(): ?float
    {
        return $this->lng;
    }

    public function setLng(?float $lng): static
    {
        $this->lng = $lng;

        return $this;
    }

    public function getBibliographies(): ?int
    {
        return $this->bibliographies;
    }

    public function setBibliographies(int $bibliographies): static
    {
        $this->bibliographies = $bibliographies;

        return $this;
    }

    public function getPeriod(): ?string
    {
        return $this->period;
    }

    public function setPeriod(?string $period): static
    {
        $this->period = $period;

        return $this;
    }

    public function getGenericLocation(): ?string
    {
        return $this->genericLocation;
    }

    public function setGenericLocation(?string $genericLocation): static
    {
        $this->genericLocation = $genericLocation;

        return $this;
    }

    public function getShortDescription(): ?string
    {
        return $this->shortDescription;
    }

    public function setShortDescription(?string $shortDescription): static
    {
        $this->shortDescription = $shortDescription;

        return $this;
    }

    public function jsonSerialize(): array
    {
        return [
            'denomination' => $this->denomination,
            'genericLocation' => $this->genericLocation,
            'period' => $this->period,
            'shortDescription' => $this->shortDescription,
            //'bibliografia' => $this->bibliographies,
            'coordinates' => [$this->lat, $this->lng],
        ];
    }
}
